#! /usr/bin/perl
#
# $Id: resolve_hostnames.pl
#
# Originally written by Vicki Irwin,
# "One of the nation's top intrusion detection analysts."
# formerly of the Naval Surface Warfare Center.
#
# Modified by Bill Ralph, "One of those highly (over) paid government
# contractors.
#
use Socket;

$filein = $ARGV[0];
open(IN,"$filein");

$fileout = $filein . "." . "resolved";
open(OUT,">$fileout");

while(<IN>)

{

   #bring in original data line
   $dataline = $_;
   @fields = split(/\s+/,$dataline);
   $srcip = $fields[1];
   $dstip = $fields[3];
   
     
   if ($srcip)
   {
   # strip off ports if they exist
      @srcoctets = split(/\./,$srcip);
      $srcip = "$srcoctets[0].$srcoctets[1].$srcoctets[2].$srcoctets[3]";

      @dstoctets = split(/\./,$dstip);
      $dstip = "$dstoctets[0].$dstoctets[1].$dstoctets[2].$dstoctets[3]";

      if ($ip_name{$srcip}) {
         $srcname = $ip_name{$srcip};
      } elsif (($srcoctets[3] == 0) or ($srcoctets[1] == 255) or 
             ($srcoctets[2] == 255) or ($srcoctets[3] == 255) or 
             ($srcoctets[4] == 255)) {
             $srcname = "";
      } else {
   
       #resolve hostnames
         $binip = pack "c4",$srcoctets[0],$srcoctets[1],$srcoctets[2],$srcoctets[3];
         @info = gethostbyaddr($binip,AF_INET);
         $srcname = $info[0];
     
         $ip_name{$srcip} = $srcname;
      }
   
      if ($ip_name{$dstip})
      {
         $dstname =  $ip_name{$dstip};
      } elsif (($dstoctets[3] == 0) or ($dstoctets[1] == 255) or 
             ($dstoctets[2] == 255) or ($dstoctets[3] == 255) or 
             ($dstoctets[4] == 255)) {
             $dstname =  "";
      } else {
         $binip = pack "c4",$dstoctets[0],$dstoctets[1],$dstoctets[2],$dstoctets[3];
         @info = gethostbyaddr($binip,AF_INET);
         $dstname = $info[0];
	      
         $ip_name{$dstip} = $dstname;
      }
   
       #replace ip addresses with hostnames

          $dataline =~ s/$srcip/$srcname/ if ($srcname);
        
          $dataline =~ s/$dstip/$dstname/ if ($dstname);
          
      print OUT $dataline;
   } else {
      print OUT "\n";
   }

}
close(IN);
close(OUT);

print "Results are in file ",$fileout,"\n";
