#!/bin/sh
#
# description: Starts and stops the Secure Shell Daemon.

# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Check that networking is up.
[ ${NETWORKING} = "no" ] && exit 0

# See how we were called.
case "$1" in
  start)
	echo -n "Starting SSHD services: "
	daemon /usr/local/sbin/sshd
	echo
	touch /var/lock/subsys/sshd
	;;
  stop)
	echo -n "Shutting down SSHD services: "
	killproc sshd
	rm -f /var/lock/subsys/sshd
	echo ""
	;;
  status)
	status sshd
	;;
  restart)
	echo -n "Restarting SSHD services: "
	echo -n "sshd "
	kill -HUP `pidof -s sshd`
	echo "done."
	;;
  *)
	echo "Usage: sshd {start|stop|restart|status}"
	exit 1
esac

